/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/2/14 first release		*/
/*					*/
/****************************************/
#include <macro.h>
#include "fatdef.h"
#include "mes.h"
#include "conf.h"

#define	RAM_NUM	1

typedef struct {
	int	start, size;
	int	offset;
	FDC	fdc;
} raminfo;
static raminfo		*ram;
extern BUSConf	ramdisk_config[];

static int open_ram(int minor, int option) {
	int	i, ret;

	if(minor >= RAM_NUM) return -1;
	ram[minor].offset = 0;
	return 0;
}

static int close_ram(int minor) {
	if(minor >= RAM_NUM) return -1;
	return 0;
}

static int write_ram(int minor, char *buffer, int size) {
	int	i, address;
	char	c, *data;

	if(minor >= RAM_NUM) return -1;
	if((ram[minor].offset + size) <= (SECSIZ * 2)) return 0;
	address = ram[minor].offset - (SECSIZ * 2);
	address += ram[minor].start;
	task_sw_ctl(1);
	data = (char*)address;
	memcpy(data, buffer, size);
	task_sw_ctl(0);
	return size;
}

static int read_ram(int minor, char *buffer, int size) {
	int	i, address;
	char	c, *data;

	if(minor >= RAM_NUM) return -1;
	if((ram[minor].offset + size) <= (SECSIZ * 2)) {
		address = ram[minor].offset;
		for(i = 0;i < size;i++) {
			c = 0;
			if(address == 0x1c2) c = 4;
			if(address == 0x1c6) c = 1;
			if(address >= SECSIZ && address < (SECSIZ + sizeof(FDC))) {
				data = (char*)&(ram[minor].fdc);
				c = data[address - SECSIZ];
			}
			if(address == (0x1fe + SECSIZ)) c = 0x55;
			if(address == (0x1ff + SECSIZ)) c = 0xaa;
			buffer[i] = c;
			address++;
		}
	} else {
		address = ram[minor].offset - (SECSIZ * 2);
		address += ram[minor].start;
		task_sw_ctl(1);
		data = (char*)address;
		memcpy(buffer, data, size);
		task_sw_ctl(0);
	}
	return size;
}

static int seek_ram(int minor, int pos) {
	int	sec, n;

	if(minor >= RAM_NUM) return -1;
	sec = pos / SECSIZ;
	if(sec >= le16toh(ram[minor].fdc.ts)) return -1;
	ram[minor].offset = pos;
	return 0;
}

static int ioctl_ram(int minor, int data, int op) {
	int	ret;

	if(minor >= RAM_NUM) return -1;
	ret = 0;
	switch(op) {
	case DEV_INFO:
		break;
	default:
		ret = -1;
	}
	return ret;
}

static Functions func = {
	open_ram,
	close_ram,
	write_ram,
	read_ram,
	seek_ram,
	ioctl_ram,
	0,
	"ram"
};

void* init_ram() {
	int		minor;
	int		n, sec, port;
	char		*data, data_bit;
	IOREG		*data_reg;

	ram = (raminfo *)__malloc(SuperTask, sizeof(raminfo) * RAM_NUM);
	for(minor = 0;minor < RAM_NUM;minor++) {
		ram[minor].start = ramdisk_config[minor].memaddr;
		ram[minor].size = ramdisk_config[minor].memsize;
		sec = ram[minor].size / SECSIZ;
		ram[minor].offset = 0;
		bzero((char*)&(ram[minor].fdc), sizeof(FDC));
		ram[minor].fdc.Boot[0] = 0xeb;
		ram[minor].fdc.ss = htole16(SECSIZ);
		ram[minor].fdc.sc = 1;
		ram[minor].fdc.rsc = htole16(1);
		ram[minor].fdc.fn = 2;
		n = ((sec * sizeof(Entry)) / (SECSIZ * 2)) * SECSIZ;
		n = n / sizeof(Entry);
		ram[minor].fdc.rde = htole16(n);
		ram[minor].fdc.ts = htole16(sec + 2);
		ram[minor].fdc.ident = 0;
		n = (sec * 2) / SECSIZ;
		ram[minor].fdc.sf = htole16(n + 1);
		data = (char*)ram[minor].start;
		if(ramdisk_config[minor].res_port != 0xff) {
			port = ramdisk_config[minor].res_port;
			data_reg = get_dr(port);
			data_bit = 1 << ramdisk_config[minor].res_bit;
		}
		if(ramdisk_config[minor].res_port == 0xff || !(*data_reg & data_bit)) {
			bzero(data, ram[minor].size);
		}
	}
	return (void*)&func;
}
